import classes from './text-input.module.scss';

const Input = ({
  id = Math.random().toString(),
  label,
  touched,
  error,
  value,
  onChange,
  name,
  type
}) => {
  return (
    <div className={classes.container}>
      {label && <label htmlFor={id} className={classes['container__label']}>{label}</label>}
      <input type={type} id={id} name={name} value={value} onChange={onChange} className={classes['container__input']} />
      {touched && error && <span className={classes['container__error']}>{error}</span>}
    </div>
  )
}

export default Input;