import { takeLatest, call, put } from 'redux-saga/effects';

import * as types from './types';
import * as actions from './actions'

import { getToken } from 'utils/local-storage-actions';

const setRequest = (data, token) => {
  return fetch('https://test-request-4b9d7.firebaseio.com/data.json', {
    method: "POST",
    headers: {
      Authorization: `Bearer ${token}`,
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(data),
  }).then(r => r.json())
}

const getUsersRequest = () => fetch('https://first-fly.firebaseio.com/users.json').then(r => r.json())

function* setData({ payload }) {
  const token = getToken();
  try {
    const result = yield call(setRequest, payload, token);
    console.log('result', result);

    // yield put(actions.getUsersSuccess(result))
  } catch (error) {
    // yield put(actions.getUsersFail(error))
  }
}

function* getUsers({ payload }) {
  try {
    const result = yield call(getUsersRequest);
    console.log('result', result);

    yield put(actions.getUsersSuccess(result))
  } catch (error) {
    yield put(actions.getUsersFail(error))
  }
}

export default function* data() {
  yield takeLatest(types.SET_DATA, setData);
  yield takeLatest(types.GET_USERS, getUsers);
}