import * as types from './types';

const initialState = {
  data: [],
  isFetching: false,
  value: ''
}

export const fakeReducer = (state = initialState, action) => {
  switch(action.type) {
    case types.GET_FAKE_DATA: {
      return { ...state, isFetching: true }
    }
    case types.GET_FAKE_DATA_SUCCESS: {
      return { ...state, isFetching: false, data: action.payload }
    }
    case types.GET_FAKE_DATA_FAIL: {
      return { ...state, isFetching: false }
    }
    case types.UPDATE_VALUE: {
      return { ...state, value: action.payload }
    }

    default: {
      return state;
    }
  }
}