import { createStore, applyMiddleware } from 'redux';
import createSagaMiddleware from 'redux-saga';
import logger from 'redux-logger';
import thunk from 'redux-thunk';

import rootSaga from './saga';
import { rootReducer } from './root-reducer';

const sagaMiddleware = createSagaMiddleware();

const middlewares = [thunk, sagaMiddleware];

if (process.env.NODE_ENV === 'development') {
  middlewares.push(logger);
}

const store = createStore(rootReducer,  applyMiddleware(...middlewares));

export default store;

sagaMiddleware.run(rootSaga);

// const mm = (state) => (next) => (action) => {
//   if (typeof action === 'function') {
//     return next(state.dispatch, state.getState);
//   }

//   return next(action);
// }